local AddOn = LibStub("AceAddon-3.0"):GetAddon("Enhancer");
local L = LibStub("AceLocale-3.0"):GetLocale("Enhancer")

local format, len = string.format, string.len;
local gsub = string.gsub;

AddOn.newsCurrent = 1; -- Can only ever increase
function AddOn:News(override)
	if (not override and ((self.db.profile.newsItem or 0) >= AddOn.newsCurrent)) then return; end
	self:CreateNewsFrame();
	
	self.newsFrame:Clear();
	self.newsFrame.title:SetText("|cffffd200"..L["ENHANCER"].."|r");
	self.newsFrame.disclaimer:SetText(L["News Disclaimer"]);
	
	-------- max length for "subject    ","body"---------------------------------------------------
	self.newsFrame:AddLine("Patch 2.4", 	"Much of the functionality in |cffffff9aEnhancer|r broke in |cffffff9a2.4|r");
	self.newsFrame:AddLine("", 						"rather then trying to fix it I decided to recode it");
	self.newsFrame:AddLine("", 						"from scratch. Part of the reason for recoding was");
	self.newsFrame:AddLine("", 						"that |cffffff9aAce3|r was released during this time (atleast bits");
	self.newsFrame:AddLine("", 						"of it ;) and I wanted to port Enhancer|cffffff9a.|r As my first");
	self.newsFrame:AddLine("Equivalence", "step in porting to |cffffff9aAce3|r I did the |cffffff9aEquivalence Points|r");
	self.newsFrame:AddLine("", 						"part and broke it out into it's own AddOn. In my");
	self.newsFrame:AddLine("", 						"oppinion it's better but *shrug*");
	self.newsFrame:AddLine("Try it", 			"http://files.wowace.com/EquivalencePoints");
	self.newsFrame:AddLine("", 						"");
	self.newsFrame:AddLine("Stay Tuned", 	"Yes not everything is back yet but I do plan to bring");
	self.newsFrame:AddLine("", 						"most of it back as soon as I can. Personal life is");
	self.newsFrame:AddLine("", 						"unfortunately holding me back a tiny bit.");
	-------- max length for "subject    ","body"---------------------------------------------------
	self.newsFrame:AddLine("", 						""); -- Some spacing
	self.newsFrame:AddLine("", 						"");
	
	self.newsFrame:AddLine(L["Command"],	format(L["'/%s %s' or '/%s %s'"], L["/Enh"], L["cmd name Config"], L["/Enhancer"], L["cmd name Config"]));
	self.newsFrame:AddLine(L["Website"],	self:SpamSafe(L["__URL__"]));
	self.newsFrame:AddLine(L["E-mail"],		self:SpamSafe(L["__EMAIL__"]));
	self.newsFrame:AddLine("", 					"");
	self.newsFrame:AddLine("", 					"THANK YOU:");
	self.newsFrame:AddLine("Isolde", 		"for putting up with me!");
	
	-- do return; end
	self.newsFrame:Show();
	self.db.profile.newsItem = AddOn.newsCurrent;
end

function AddOn:SpamSafe(text)
	-- replace ' [dot] ' with '.' and ' [at] ' with '@'
	return gsub(gsub(text, " %[at%] ", "@"), " %[dot%] ", ".");
end

function AddOn:CreateNewsFrame()
	AddOn.newsFrame = CreateFrame("Frame", "AddOnNewsFrame", UIParent, "DialogBoxFrame")
	AddOn.newsFrame:SetWidth(500)
	AddOn.newsFrame:SetHeight(400)
	AddOn.newsFrame:SetPoint("CENTER")
	AddOn.newsFrame:SetBackdrop({
		bgFile = [[Interface\DialogFrame\UI-DialogBox-Background]],
	    edgeFile = [[Interface\Tooltips\UI-Tooltip-Border]],
	    tile = true, tileSize = 16, edgeSize = 16,
	    insets = { left = 5, right = 5, top = 5, bottom = 5 }
	})
	AddOn.newsFrame:SetBackdropColor(0,0,0,1)

	local text = AddOn.newsFrame:CreateFontString(nil, "OVERLAY", "GameFontHighlightLarge")
	text:SetFont([[Interface\AddOns\Enhancer\fonts\CAS_ANTN.TTF]], 24, "OUTLINE"); -- http://wdnaddons.com/2307561/FrameXML/Fonts.xml
	AddOn.newsFrame.title = text
	text:SetPoint("TOP", 0, -5)

	AddOn.newsFrame:Hide()

	AddOn.newsFrame.lefts = {}
	AddOn.newsFrame.rights = {}
	AddOn.newsFrame.textLefts = {}
	AddOn.newsFrame.textRights = {}
	function AddOn.newsFrame:Clear()
		self.title:SetText("")
		self.disclaimer:SetText("")
		for i = 1, #self.lefts do
			self.lefts[i] = nil
			self.rights[i] = nil
		end
	end
	
	local function rightColor(right)
		-- Email color as link
		right = gsub(right, "[A-Za-z0-9%.%%%+%-]+@[A-Za-z0-9%.%%%+%-]+%.%w%w%w?%w?", function(v) return "|cff007fff"..v.."|r"; end)
		
		-- URL color as link (is crap need better URL matching)
		right = gsub(right, "http%:%/%/[A-Za-z0-9%.%/]+", function(v) return "|cff007fff"..v.."|r"; end)
		
		-- '-quoted color greenish
		right = gsub(right, "(%')(%/%w-%s?%w-)(%')", function(v1, v2, v3) return v1.."|cffcccccc"..v2.."|r"..v3; end) --00ff7f
		
		-- return the mess
		return right;
	end

	function AddOn.newsFrame:AddLine(left, right)
		AddOn.newsFrame.lefts[#AddOn.newsFrame.lefts+1] = left;
		AddOn.newsFrame.rights[#AddOn.newsFrame.rights+1] = rightColor(right);
	end

	local newsFrame_Show = AddOn.newsFrame.Show
	function AddOn.newsFrame:Show(...)
		local maxLeftWidth = 0
		local maxRightWidth = 0
		local textHeight = 0
		for i = 1, #self.lefts do
			if not self.textLefts[i] then
				local left = AddOn.newsFrame:CreateFontString(nil, "OVERLAY", "GameFontNormal")
				left:SetFont([[Interface\AddOns\Enhancer\fonts\CAS_ANTN.TTF]], 12, "OUTLINE");
				self.textLefts[i] = left
				local right = AddOn.newsFrame:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
				right:SetFont([[Interface\AddOns\Enhancer\fonts\Cella.ttf]], 10, "OUTLINE");
				self.textRights[i] = right
				if i == 1 then
					left:SetPoint("TOPRIGHT", AddOn.newsFrame, "TOPLEFT", 75, -35)
				else
					left:SetPoint("TOPRIGHT", self.textLefts[i-1], "BOTTOMRIGHT", 0, -1)
				end
				right:SetPoint("LEFT", left, "RIGHT", 5, 0)
			end
			self.textLefts[i]:SetText(self.lefts[i] .. ((len(self.lefts[i]) > 0 and len(strtrim(self.lefts[i])) > 0 and ":") or " "))
			self.textRights[i]:SetText(self.rights[i])
			local leftWidth = self.textLefts[i]:GetWidth()
			local rightWidth = self.textRights[i]:GetWidth()
			textHeight = self.textLefts[i]:GetHeight()
			if maxLeftWidth < leftWidth then
				maxLeftWidth = leftWidth
			end
			if maxRightWidth < rightWidth then
				maxRightWidth = rightWidth
			end
		end
		for i = #self.lefts+1, #self.textLefts do
			self.textLefts[i]:SetText('')
			self.textRights[i]:SetText('')
		end
		local finalWidth = 85 + maxRightWidth + 20 + 30;
		if (finalWidth < 360) then finalWidth = 360; end
		AddOn.newsFrame:SetWidth(finalWidth)
		AddOn.newsFrame:SetHeight(#self.lefts * (textHeight + 1) + 100)

		newsFrame_Show(self, ...)
	end
	AddOn.newsFrame:Hide()
	
	local disclaimer = AddOn.newsFrame:CreateFontString(nil, "OVERLAY", "GameFontHighlightSmall")
	disclaimer:SetFont([[Interface\AddOns\Enhancer\fonts\Cella.ttf]], 8, "");
	AddOn.newsFrame.disclaimer = disclaimer
	disclaimer:SetPoint("BOTTOMRIGHT", AddOn.newsFrame:GetName(), "BOTTOMRIGHT", -5, 5)
	
	AddOn.CreateNewsFrame = function() return; end;
end