--[[ Local                                                            ]]
local LibStub = _G["LibStub"];
assert(LibStub, "Error, Enhancer requires LibStub");

--[[ Create                                                           ]]
local L = LibStub("AceLocale-3.0"):NewLocale("Enhancer", "enUS", true)

--[[ Add Stuff                                                        ]]

-- Just vanity stuff
L["__URL__"] = "http://files [dot] wowace [dot] com/Enhancer";
L["__EMAIL__"] = "dennis [dot] hafstrom [at] gmail [dot] com";

-- _
L["_print"] = "|cff" .. "ffdc5f" .. "Enhancer" .. "|r" .. ":";
L["_debug"] = "|cff" .. "ff7777" .. "Enhancer Debug [%s]" .. "|r" .. ":"; -- %s = time

L["Totem gsub"] = "Totem";

-- slash
L["/Enhancer"] = "Enhancer";
L["/Enh"] = "Enh";
L["/Enhance"] = "Enhance";

-- cmd Groups
L["cmd name Enhancer"] = "Enhancer";
L["cmd name quickcast"] = "QuickCast";
L["cmd name buttonsettings"] = "ButtonSettings";
L["cmd name textsettings"] = "TextSettings";
L["cmd name layout"] = "Layout";

-- cmd Headers
L["Earth macro text"] = "Earth macro totem (cast on left-click, set to blank to use queue-system)";
L["Fire macro text"] = "Fire macro totem (cast on left-click, set to blank to use queue-system)";
L["Water macro text"] = "Water macro totem (cast on left-click, set to blank to use queue-system)";
L["Air macro text"] = "Air macro totem (cast on left-click, set to blank to use queue-system)";
L["cmd header Measures"] = "Measures";
L["cmd header Opacity"] = "Opacity";
L["cmd header Top"] = "Top";
L["cmd header Center"] = "Center";
L["cmd header Bottom"] = "Bottom";
L["cmd header Messages"] = "Messages";

-- cmd Normal
L["cmd name Config"] = "Config";
L["cmd desc Config"] = "Open config";
L["cmd name locked"] = "Lock";
L["cmd desc locked"] = "Prevents buttons from accidently moving";
L["cmd name tooltip"] = "Tooltips";
L["cmd desc tooltip"] = "Show tooltips when hovering over buttons";
L["cmd name debug"] = "Debug";
L["cmd desc debug"] = "Show debug messages";
L["cmd name hideblizz"] = "Hide";
L["cmd desc hideblizz"] = "Toggle showing of Blizzard totem frames";
L["cmd name btnwidth"] = "Size";
L["cmd desc btnwidth"] = "Sets width/height for buttons";
L["cmd name activealpha"] = "Active";
L["cmd desc activealpha"] = "Opacity for the buttons when they are active";
L["cmd name inactivealpha"] = "Inactive";
L["cmd desc inactivealpha"] = "Opacity for the buttons when they are inactive (during combat)";
L["cmd name oocalpha"] = "OOC";
L["cmd desc oocalpha"] = "Opacity for the buttons when they are inactive and you are out of combat";
L["cmd name font"] = "Font";
L["cmd desc font"] = "Set wich font to use";
L["cmd name fontsize"] = "Size";
L["cmd desc fontsize"] = "Size for the font";
L["cmd name fontflags"] = "Outline";
L["cmd desc fontflags"] = "Outline for the font";
local tags = "%element%, %name%";
L["cmd name natural"] = "Lost";
L["cmd desc natural"] = "Text to display when a totem is lost naturally (range/duration/etc), tags: " .. tags;
L["cmd name slain"] = "Slain";
L["cmd desc slain"] = "Text to display when a totem is slain, tags: " .. tags;
L["cmd name below"] = "Below";
L["cmd desc below"] = "Position frames centered below player";
L["cmd name xpos"] = "XPos";
L["cmd desc xpos"] = "Position frames as an X around player";
L["cmd name resetdb"] = "Reset";
L["cmd desc resetdb"] = "Resets all settings from current profile";
L["cmd name news"] = "News";
L["cmd desc news"] = "Display the news window in case you missed something really important in there ;)";

-- Outline
L["None"] = true;
L["Outline"] = true;
L["Thick Outline"] = true;

-- Elements
L["Earth"] = true;
L["Fire"] = true;
L["Air"] = true;
L["Water"] = true;

-- Alerts
L["totem lost"] = "%element% totem [%name%] lost";
L["totem slain"] = "%element% totem [%name%] SLAIN!!";
L["%s totem lost"] = true;
L["%s totem was SLAIN!!"] = true;

-- News stuff
L["Enhancer"] = true;
L["ENHANCER"] = true;
L["Command"] = true;
L["Website"] = true;
L["E-mail"] = true;
L["News Disclaimer"] = "News is only shown on first load!";
L["'/%s %s' or '/%s %s'"] = true;